<template>
  <div class="ob-aside">
    <ob-tabs
        :items="tabsItems"
        @on-change-tab="onChangeTab"
    >
      <ob-tabs-pane :title="tabsItems[0].title">
        <div class="ob-tabs-pane-wrap">
          <div class="ob-aside__title">Тип аукциона</div>

          <div class="ob-radio-group">
            <ob-radio
                :label="auction.DOWNGRADE.title"
                :valueInput="auction.DOWNGRADE.value"
                :tooltip="auction.DOWNGRADE.titleShort"
                v-model="auctionType"
                @change="onChangeField"
            />
            <ob-stepper
                v-if="auctionType === auction.DOWNGRADE.value"
                label="Шаг аукциона, ₽"
                :step="1000"
                :minValue="0"
                :maxValue="100000"
                :allowNegatives="false"
                :modelValue="auctionStepPenny"
                data-qa="stepOfAuction"
                @input="onChangeStep"
            />
            <ob-radio
                :label="auction.FIRST_APPROVE.title"
                :valueInput="auction.FIRST_APPROVE.value"
                :tooltip="auction.FIRST_APPROVE.titleShort"
                v-model="auctionType"
                data-qa="firstApproveAuction"
                @change="onChangeField"
            />
            <ob-radio
                :label="auction.BLIND.title"
                :valueInput="auction.BLIND.value"
                :tooltip="auction.BLIND.titleShort"
                v-model="auctionType"
                data-qa="blindAuction"
                @change="onChangeField"
            />
          </div>

          <div class="ob-aside__info" v-if="isError">
            <div class="ob-aside__info-icon">
              <div class="icon checked"></div>
            </div>
            <div class="ob-aside__info-text">
              {{ theFirstError.description }}
            </div>
          </div>

          <template v-if="auctionType !== auction.BLIND.value">
            <div class="ob-aside__title">Стартовая цена</div>
            <div class="ob-radio-group">
              <ob-radio
                  :label="startPrice.WITHOUT_NDS.title"
                  :valueInput="startPrice.WITHOUT_NDS.value"
                  v-model="startPriceModel"
                  data-qa="startPriceWithoutNds"
                  @change="onChangeField"
              />
              <ob-input
                  v-model.number="startPriceValue"
                  type="money"
                  :isTrimOnBlur="false"
                  :required="true"
                  subTitle="₽"
                  label="Стартовая цена"
                  placeholder="Укажите"
                  data-qa="startPrice"
                  @input="onChangeField"
              />
              <ob-radio
                  :label="startPrice.ONLINE.title"
                  :valueInput="startPrice.ONLINE.value"
                  :disabled="true"
                  v-model="startPriceModel"
                  data-qa="startOnlinePrice"
                  @change="onChangeStartPriceRadio"
              />

              <div class="ob-aside__loader" v-if="isOnlinePriceLoader">
                <ob-loader :width="30" :height="30" />
              </div>
            </div>
          </template>

          <div class="ob-aside__title">Старт аукциона</div>

          <div class="mb15">
            <ob-checkbox
                label="Начать аукцион немедленно"
                v-model="isStartImmediately"
                data-qa="startImmediately"
                @change="onChangeStartImmediately"
            />
          </div>

          <ob-date-picker
              v-if="!isStartImmediately"
              v-model="auctionStartDate"
              label="Аукцион начнётся"
              placeholder="Укажите"
              :is-valid-date="isValidStartDate"
              :block-before="true"
              :readonly="false"
              :is-time="true"
              position="bottom-end"
              data-qa="auctionStartDate"
              key="auctionStartDate"
              @input="onChangeField"
          />

          <div class="ob-aside__title">Длительность аукциона</div>

          <ob-control-group
              v-model="auctionRangeValue"
              :items="auctionRange"
              data-qa="auctionRangeQa"
              height="slim"
              theme="light"
              :multiselect="false"
              :disabled="false"
              @input="onChangeControlGroup"
          />

          <ob-date-picker
              v-if="isAuctionEndDate"
              v-model="auctionEndDate"
              label="Аукцион завершится"
              placeholder="Укажите"
              :block-before="true"
              :readonly="false"
              :is-time="true"
              :is-valid-date="isValidEndDate"
              position="bottom-end"
              data-qa="auctionEndDate"
              key="auctionEndDate"
              @input="onChangeField"
          />
        </div>
      </ob-tabs-pane>

      <ob-tabs-pane :title="tabsItems[1].title">
        <ob-func-panel
            @search="onSearch"
            :columns="columnsParticipants"
            :show-column-filter="false"
            :show-filter="false"
            :show-group="false"
            :show-sort="false"
            data-qa="searchParticipants"
        />
        <ObTable
            v-if="participantsItems.length && spotItem.main.contractor.uuid"
            ref="participants-table"
            class="participants-table"
            :is-fixed-header="false"
            :columns="columnsParticipants"
            :items="participantsItemsSearch"
            :table-layout-fixed="false"
            :is-header="false"
            :functional-panel="false"
            :with-checkboxes="true"
            :checked-rows="participantsUuid"
            group-by="group"
            data-qa="participantsTable"
            @row-toggle="onToggle"
            @group-toggle="onToggle"
        >
          <template #participant="{data}">
            <participantSlot :item="data.item" />
          </template>
          <template #noneContent>
            <p>Создайте
              <router-link to="/browser_link__groups">рабочую группу</router-link>
              для добавления участников.
            </p>
          </template>
        </ObTable>
      </ob-tabs-pane>
    </ob-tabs>

    <div class="ob-tabs-pane-wrap">
      <p class="align-c mb30">
        Выбрано участников: {{ participantCounter }}
      </p>

      <ob-button
          :isFullWidth="true"
          :dark="true"
          :disabled="isError || (!hasAuctionEndDate && isAuctionRangeEmpty) || blockButton"
          label="Отторговать лот"
          type="primary-success"
          data-qa="btnLot"
          @click="onPublicDraft"
      />
    </div>
  </div>
</template>

<script>
import api from '@/api'
import debounce from 'debounce'
import { formatNumber } from 'common-components/src/helpers/common'
import { AUCTION_TYPES } from '@/resources/enum'
import { mapGetters } from 'vuex'
import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor/index'
import ObInput from 'common-components/src/obComponents/obInput/index'
import obStepper from 'common-components/src/obComponents/obStepper/index'
import ObCheckbox from 'common-components/src/obComponents/obCheckbox/index'
import ObRadio from 'common-components/src/obComponents/obRadio/index'
import obButton from 'common-components/src/obComponents/obButton/index'
import ObControlGroup from 'common-components/src/obComponents/obControlGroup/index'
import ObTable from 'common-components/src/obComponents/obTable/index'
import ObTabs from 'common-components/src/obComponents/obTabs/index'
import ObTabsPane from 'common-components/src/obComponents/obTabs/ObTabsPane'
import ObFuncPanel from 'common-components/src/obComponents/obFuncPanel';
import participantSlot from '@/pages/spotPage/slots/participant'

export default {
  name: 'spotDraftItemSettings',
  components: {
    ObDatePicker,
    ObInput,
    obStepper,
    ObCheckbox,
    ObRadio,
    obButton,
    ObControlGroup,
    ObTable,
    ObTabs,
    ObTabsPane,
    ObFuncPanel,
    participantSlot
  },
  props: {
    settings: {
      type: Object,
      default: () => {
      }
    },
    isCopyItem: {
      type: Boolean,
      default: false,
    },
    loadingAt: {
      type: [String, Number, Date]
    },
    blockButton: {
      type: Boolean,
      default: false
    }
  },
  mounted () {
    this.getParticipantsGroups();
  },
  data () {
    return {
      search: '',
      tabsItems: [
        {
          id: 1,
          name: 'settings',
          title: 'Настройки'
        },
        {
          id: 2,
          name: 'participant',
          title: 'Участники'
        }
      ],
      auction: AUCTION_TYPES,
      auctionType: this.settings.type || 'DOWNGRADE',
      auctionStep: this.settings.step || 100000,
      auctionStartDate: this.settings.startPlanDt || null,
      auctionEndDate: this.settings.endPlanDt || null,
      auctionRangeValue: this.settings.duration ? this.settings.duration + 'h' : 'empty',
      auctionRange: [
        {
          label: '1ч',
          value: '1h'
        },
        {
          label: '2ч',
          value: '2h'
        },
        {
          label: '3ч',
          value: '3h'
        },
        {
          icon: 'settings',
          value: 'empty'
        }
      ],
      startPrice: {
        WITHOUT_NDS: {
          title: 'Назначить цену (без НДС)',
          value: 'WITHOUT_NDS'
        },
        ONLINE: {
          title: 'Рассчитать онлайн-цену',
          value: 'ONLINE'
        },
        WAITFORONLINE: {
          title: 'Идёт расчёт онлайн-цены',
          value: 'WAITFORONLINE'
        }
      },
      startPriceValue: this.settings.startPrice || null,
      startPriceModel: 'WITHOUT_NDS',
      isOnlinePriceLoader: false,
      isAuctionEndDate: !this.settings.duration,
      isStartImmediately: !this.settings.startPlanDt,
      currentDateISO: (new Date()).toISOString(),

      participantsUuid: this.settings.participants.length ? this.settings.participants : [],
      participantsItems: [],
      columnsParticipants: [{
        key: 'participant',
        width: '200',
        slotName: 'participant'
      }],
      participantCounter: 0
    }
  },
  computed: {
    ...mapGetters({
      spotItem: 'spot/spotItem',
      spotErrors: 'spot/spotErrors'
    }),
    isError () {
      return !!this.spotErrors.length
    },
    theFirstError () {
      return this.spotErrors.length ? this.spotErrors[0] : '-'
    },
    isValidStartDate () {
      const _d = new Date(this.loadingAt);
      if (this.auctionRangeValue !== 'empty') {
        _d.setHours(_d.getHours() - Number.parseInt(this.auctionRangeValue))
      }
      return this.toISOString(this.auctionStartDate) < _d.toISOString()
          && this.toISOString(this.auctionStartDate) > this.currentDateISO
    },
    isValidEndDate () {
      return (this.toISOString(this.auctionEndDate) > (this.toISOString(this.auctionStartDate) || this.currentDateISO)
          && this.toISOString(this.auctionEndDate) < this.toISOString(this.loadingAt))
    },
    auctionStepPenny () {
      return this.auctionStep / 100;
    },
    auctionFields () {
      return {
        type: this.auctionType,
        step: this.auctionStep,
        startPrice: this.startPriceValue,
        isManualStartPrice: this.startPriceModel === 'WITHOUT_NDS',
        duration: this.auctionRangeValue === 'empty' ? null : Number.parseInt(this.auctionRangeValue),
        startPlanDt: this.auctionStartDate,
        endPlanDt: this.auctionEndDate,
        participants: this.participantsUuid
      }
    },
    participantsItemsSearch () {
      if (this.search !== '') {
        return this.participantsItems.filter(item => {
          let str = item.title + ' ' + item.inn;
          return str.toLowerCase().includes(this.search.toLowerCase())
        })
      }
      return this.participantsItems
    },
    isAuctionRangeEmpty () {
      return this.auctionRangeValue === 'empty'
    },
    hasAuctionEndDate () {
      return Boolean(this.auctionEndDate)
    }
  },
  watch: {
    'participantsItemsSearch' (participant) {
      const count = participant.filter(key => key.checked === true).map(key => key.checked);
      this.participantCounter = count ? count.length : 0;
    },
    'participantsUuid' (participants) {
      this.participantCounter = participants.length
    }
  },
  methods: {
    formatNumber,

    toISOString (date) {
      return (new Date(date)).toISOString()
    },

    onChangeStartImmediately (flag) {
      if (flag) {
        this.auctionStartDate = null
      } else {
        const _d = new Date(this.toISOString(this.loadingAt))
        if (this.auctionRangeValue !== 'empty') {
          _d.setHours(_d.getHours() - Number.parseInt(this.auctionRangeValue))
        }
        this.auctionStartDate = _d.toISOString()
      }
      this.onChangeField()
    },

    onChangeStartPriceRadio () {
      this.isOnlinePriceLoader = true
      this.startPrice.ONLINE.title = 'Идёт расчёт онлайн-цены'

      const test = `<div class="ob-price"><span class="ob-price__total">${this.formatNumber(32300)} ₽ </span><span class="ob-price__note">без НДС</span></div><div>Онлайн-цена</div>`
      setTimeout(() => {
        this.startPrice.ONLINE.title = test
        this.isOnlinePriceLoader = false
        return true; // todo: временно для демонстрации
      }, 2000)
    },

    onChangeControlGroup (e) {
      if (e === 'empty') {
        this.isAuctionEndDate = true

        const _d = new Date(this.auctionStartDate || this.toISOString(this.loadingAt))
        if (!this.isAuctionRangeEmpty) {
          _d.setHours(_d.getHours() + Number.parseInt(this.auctionRangeValue))
        }
        this.auctionEndDate = this.toISOString(_d)
      } else {
        this.isAuctionEndDate = false
        this.auctionEndDate = null
      }
      this.onChangeField()
    },

    onChangeStep (step) {
      this.auctionStep = step * 100;
      this.onChangeField();
    },

    onChangeField: debounce(function () {
      if (this.auctionType === 'BLIND') {
        this.startPriceValue = null
      }
      this.$emit('change', this.auctionFields)
    }, 1000),

    onPublicDraft () {
      api.spotAuction
         .publicSpotItemDraft(this.$route.params.uuid)
         .then(() => {
           this.$router.push({ name: 'spot__list' })
         })
         .catch((e) => {
           console.error(e)
           this.$notification({
             type: 'system_notification_error',
             message: 'Ошибка публикации'
           })
         })
    },

    async getParticipantsGroups (page = 0, size = 999) {
      try {
        const response = await api.spotAuction.getParticipantsGroups(
          {
            page,
            size,
            ownerUuid: this.spotItem.main.contractor.uuid
          }
        );

        this.participantsItems = this.parseParticipants(response.data).participants

        if (!this.participantsUuid.length) {
          this.participantsUuid = Array.from(new Set(this.participantsItems.map(item => item.uuid)));
        }
      } catch (e) {
        console.error(e)
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки участников"
        })
      }
    },

    parseParticipants (data) {
      return {
        ...data,
        participants: data.groups.reduce((filtered, group) => {
          return filtered.concat(group.participants.map(item => ({
            ...item,
            group: group.title || 'Без группы',
            checked: this.participantsUuid.includes(item.uuid)
          })))
        }, [])
      }
    },


    onToggle (data, participantsUuid) {
      this.participantsUuid = participantsUuid;
      this.onChangeField()
    },

    onChangeTab (item) {
      if (item.name === 'participant') {
        this.onChangeField()
      }
    },

    onSearch (e) {
      this.search = e
    }
  }
}
</script>

<style lang="scss" scoped>
@import "node_modules/common-components/src/static/css/variables";
@import "node_modules/common-components/src/static/css/mixins";

.ob-aside {
  .disabled {
    pointer-events: none;
    opacity: .2;
  }

  &__title {
    font-weight: bold;
    font-size: 16px;
    color: $color-text-base;
    margin-bottom: 19px;
  }

  &__info {
    padding: 19px 20px;
    background: rgba($Green-500, 0.1);
    display: flex;
    margin-bottom: 34px;

    &-icon {
      flex-basis: 20px;
      font-size: 24px;
      color: $Green-700;
      margin-right: 20px;
    }

    &-text {
      line-height: 20px;
    }
  }

  &__loader {
    display: flex;
    justify-content: center;
    margin-top: 15px;
  }

  .ob-radio-group {
    margin-bottom: 34px;

    .ob-radio-container {
      margin-top: 10px;
    }
  }

  .ob-stepper-container, .ob-input-container, .ob-date-picker {
    margin: 8px 0 19px;
  }

  .ob-ctrlgroup {
    margin-bottom: 7px;
  }

  .align-c {
    text-align: center;
  }

  .mb15 {
    margin-bottom: 15px;
  }

  .mb30 {
    margin-bottom: 30px;
  }

  .mt20 {
    margin-top: 20px;
  }

  .mt30 {
    margin-top: 30px;
  }

  /deep/ .ob-ctrlgroup {
    &[type="button"]:last-child {
      padding: 1px;
    }

    .ob-ctrlgroup__item {
      min-width: 20px;
      padding: 0 20px;

      &:last-of-type {
        padding: 0 12px;
      }

      .icon {
        font-size: 16px;
        margin-right: 0;
      }
    }
  }

  /deep/ .ob-price {
    &__total {
      font-weight: bold;
      font-size: 20px;
      line-height: 24px;
    }

    &__note {
      font-size: 12px;
    }
  }

  .ob-tabs-pane {
    &-wrap {
      padding: 25px 29px 25px;
    }

    &-title {
      font-weight: bold;
      font-size: 16px;
      color: $color-text-base;
      margin-bottom: 19px;
    }
  }

  .participants-table {
    /deep/ .table-data {
      min-width: 100%;
    }
  }
}
</style>
